d("remoteView",['util'], function(UTIL) {

    return {
        extendRemoteView: function() {
            if(CCRZ){
                let reqData = [
                    {
                        'name': 'reprintCategory',
                        'objectName': 'ccrz__E_CartItem__c',
                        'fieldName': 'KFB2B_Reprint_Category__c',
                        'isDependent': false
                    },
                    {
                        'name': 'reprintSubCatMap',
                        'objectName': 'ccrz__E_CartItem__c',
                        'fieldName': 'KFB2B_Reprint_Sub_Category__c',
                        'isDependent': true
                    }
                ];
                //Adding this for validating letters only
                jQuery.validator.addMethod("lettersonly", function(value, element) {
                    return this.optional(element) || /^[a-z," "]+$/i.test(value);
                }, "Letters only please"); 
                CCRZ.remoteModel.getPickListData(JSON.stringify(reqData), function(res, e){
                    if(res.success && res.data){
                        if(res.data.account){
                            CCRZ.pagevars['isCredit'] = res.data.account.DCM_Approved_For_Credit__c;
                            CCRZ.pagevars['isNonAccredited'] = res.data.account.KFB2B_Is_Non_Accredited__c;
                            CCRZ.pagevars['contactInfo'] = res.data.contact;
                            if(CCRZ.headerView){
                                if(CCRZ.pagevars.isGuest){
                                    CCRZ.headerView.model.set('contactName', '');
                                } else {
                                    CCRZ.headerView.model.set('contactName', res.data.contact.FirstName + ' ' + res.data.contact.LastName);
                                }
                                CCRZ.headerView.render();
                                CCRZ.menuView.render();
                                CCRZ.effSelectorView.render();
                            }   
                            if(CCRZ.myaccountView && CCRZ.myaccountView.navView && !_.isEmpty(CCRZ.myaccountView.navView.model) 
                                && res.data.account.KFB2B_Is_Non_Accredited__c){
                                let model = CCRZ.myaccountView.navView.model, newModel = {};
                                for(let key in model){
                                    if(model[key].title !== 'My Invoices'){
                                        newModel[key] = model[key];
                                    }
                                }
                                CCRZ.myaccountView.navView.model = newModel;
                                CCRZ.myaccountView.navView.render();
                            }
                            if(!res.data.account.KFB2B_Is_Non_Accredited__c && !CCRZ.pagevars.isGuest){
                                $('#myAccountAdvNotice').html(CCRZ.processPageLabelMap('KFB2B_myAccount_AdvNotice',[]).string);
                            } else {
                                $('.myAccountAdvCardContainer').addClass('hide');
                            }
                        } 
                        if(res.data.reprintCategory){
                            CCRZ.pagevars['reprintCategory'] = res.data.reprintCategory;
                        } else {
                            CCRZ.pagevars['reprintCategory'] = [];
                        }
                        if(res.data.reprintSubCatMap){
                            CCRZ.pagevars['reprintSubCatMap'] = res.data.reprintSubCatMap;
                        } else {
                            CCRZ.pagevars['reprintSubCatMap'] = [];
                        }
                    } else {
                        CCRZ.pagevars['reprintCategory'] = [];
                        CCRZ.pagevars['reprintSubCatMap'] = [];
                    }
                });
            }
        } 
    }
});

