d("staticPageView", ["ccrz", "util", 'staticPageModel'], function(CCRZ, UTIL, staticPageModel) {
    return {
        extendStaticPageView: function(){
            // Create Custom Contact Us View
            CCRZ.views.staticPageView = CCRZ.CloudCrazeView.extend({
                el: CCRZ.uiProperties.staticPageView.selector,
                viewName: "staticPageView",
                template: CCRZ.util.template(CCRZ.uiProperties.staticPageView.tmpl),
                init: function(){
                    this.model = new staticPageModel();
                    this.model.set('label', CCRZ.pagevars.queryParams.label);
                    this.render();
                },
                render: function(){
                    this.$el.html(this.template(this.model.toJSON()));
                    UTIL.hideLoader();
                    let target = CCRZ.pagevars.queryParams.target;
                    if(!_.isUndefined(target)){
                        $('html, body').animate({
                            'scrollTop' : $("#" + target).position().top
                        });
                    }
                    // Overriding the CC Page Label Href value to be updated to the current Site Origin URL
                    // Overriding URL function
                    $('a').each(function(aTag){
                        let currentURL = this.href, siteURL = CCRZ.pagevars.currSiteURL, buildURL = '';
                        if(currentURL.indexOf(CCRZ.pagevars.storefrontName) > -1){
                            let siteList = currentURL.split(CCRZ.pagevars.storefrontName);
                            // Check if the current Site URL has Default Store to see if its in production or sandbox
                            if(siteURL.indexOf(CCRZ.pagevars.storefrontName) > -1){
                                buildURL = window.location.origin + '/' + CCRZ.pagevars.storefrontName + siteList[1];
                            } else {
                                buildURL = window.location.origin + siteList[1];
                            }
                        }
                        this.href = buildURL;
                    });
                },
                events: {
                    'click a' : 'handleLink'
                },
                handleLink: function(event){
                    let name = event.target.name;
                    if(name.indexOf('jumpTo') > -1){
                        let jumpLinkName = name.replace('jumpTo', '').trim();
                        $('html, body').animate({
                            'scrollTop' : $("#" + jumpLinkName).position().top
                        });
                    }
                },
                postRender : function(){
                    
                }
            });
            
            CCRZ.staticPageView = new CCRZ.views.staticPageView();
        }
    };
});